# M60 Mechanical Keyboard

**En** | [中文][1]

M60 is a hot-swappable 60% Keyboard with USB, BLE 5.0 and RGB backlight. It is highly configurable and extensible.
It can run Python code saved in its USB storage, which makes it super powerful. It has very low power consumption and only needs about 160uA current when connected to a computer via Bluetooth. It is one of the lowest latency USB keyboards.

![](https://github.com/makerdiary/python-keyboard/raw/master/img/m60.jpg)

## Features

- Bluetooth, including BLE 5.0 multi-pairing up to 10 devices
- Hot-swappable key switch mounts
- USB Type-C connector
- Standard 60% layout (61 keys)
- 6KRO
- RGB backlight (pending software support)
- Supports Windows/macOS/Linux/iOS/Android
- Low power consumption
- All keys remappable
- Up to 32 layers
- Macros
- Pair-keys
- Tap-keys

## Specs

|                   | M60 Keyboard                                                                     |
| ----------------- | -------------------------------------------------------------------------------- |
| Core Module       | nRF52840, Arm Cortex-M4F, 64MHz, 256KB RAM, 1MB FLASH, 8MB QSPI Flash, M.2 KEY-E |
| Wireless          | Bluetooth Low Energy 5.0, NFC                                                    |
| USB               | Type-C                                                                           |
| Layout            | 60% (61 Keys)                                                                    |
| Hot-Swappable     | Yes                                                                              |
| Switch Option     | Cherry MX compatible Switches                                                    |
| Backlight         | 64 RGB LEDs, IS32FL3733                                                          |
| Battery Connector | JST 1.25mm 3-Pin                                                                 |
| RF Antennas       | 2.4GHz Cabled PCB Antenna, NFC Cabled PCB Antenna                                |
| Dimensions        | 285 mm x 94.6 mm (compatible with DZ60 cases)                                    |

!!! Note
    The M60 PCB uses a north-facing switch orientation. If you plan to use Cherry MX or low-profile keycaps, be sure to purchase key switches that are beveled on both the north and south ends. See Issue #3.

[1]: https://gitee.com/makerdiary/python-keyboard/wikis/pages
